/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	scheme "quark.netapp.io/volume-controller/pkg/client/clientset/versioned/scheme"
)

// NetAppThinProvisioningTuningConfigsGetter has a method to return a NetAppThinProvisioningTuningConfigInterface.
// A group's client should implement this interface.
type NetAppThinProvisioningTuningConfigsGetter interface {
	NetAppThinProvisioningTuningConfigs(namespace string) NetAppThinProvisioningTuningConfigInterface
}

// NetAppThinProvisioningTuningConfigInterface has methods to work with NetAppThinProvisioningTuningConfig resources.
type NetAppThinProvisioningTuningConfigInterface interface {
	Create(ctx context.Context, netAppThinProvisioningTuningConfig *v1alpha1.NetAppThinProvisioningTuningConfig, opts v1.CreateOptions) (*v1alpha1.NetAppThinProvisioningTuningConfig, error)
	Update(ctx context.Context, netAppThinProvisioningTuningConfig *v1alpha1.NetAppThinProvisioningTuningConfig, opts v1.UpdateOptions) (*v1alpha1.NetAppThinProvisioningTuningConfig, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.NetAppThinProvisioningTuningConfig, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NetAppThinProvisioningTuningConfigList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppThinProvisioningTuningConfig, err error)
	NetAppThinProvisioningTuningConfigExpansion
}

// netAppThinProvisioningTuningConfigs implements NetAppThinProvisioningTuningConfigInterface
type netAppThinProvisioningTuningConfigs struct {
	client rest.Interface
	ns     string
}

// newNetAppThinProvisioningTuningConfigs returns a NetAppThinProvisioningTuningConfigs
func newNetAppThinProvisioningTuningConfigs(c *QuarkV1alpha1Client, namespace string) *netAppThinProvisioningTuningConfigs {
	return &netAppThinProvisioningTuningConfigs{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the netAppThinProvisioningTuningConfig, and returns the corresponding netAppThinProvisioningTuningConfig object, and an error if there is any.
func (c *netAppThinProvisioningTuningConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NetAppThinProvisioningTuningConfig, err error) {
	result = &v1alpha1.NetAppThinProvisioningTuningConfig{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappthinprovisioningtuningconfigs").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of NetAppThinProvisioningTuningConfigs that match those selectors.
func (c *netAppThinProvisioningTuningConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NetAppThinProvisioningTuningConfigList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.NetAppThinProvisioningTuningConfigList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappthinprovisioningtuningconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested netAppThinProvisioningTuningConfigs.
func (c *netAppThinProvisioningTuningConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("netappthinprovisioningtuningconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a netAppThinProvisioningTuningConfig and creates it.  Returns the server's representation of the netAppThinProvisioningTuningConfig, and an error, if there is any.
func (c *netAppThinProvisioningTuningConfigs) Create(ctx context.Context, netAppThinProvisioningTuningConfig *v1alpha1.NetAppThinProvisioningTuningConfig, opts v1.CreateOptions) (result *v1alpha1.NetAppThinProvisioningTuningConfig, err error) {
	result = &v1alpha1.NetAppThinProvisioningTuningConfig{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("netappthinprovisioningtuningconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppThinProvisioningTuningConfig).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a netAppThinProvisioningTuningConfig and updates it. Returns the server's representation of the netAppThinProvisioningTuningConfig, and an error, if there is any.
func (c *netAppThinProvisioningTuningConfigs) Update(ctx context.Context, netAppThinProvisioningTuningConfig *v1alpha1.NetAppThinProvisioningTuningConfig, opts v1.UpdateOptions) (result *v1alpha1.NetAppThinProvisioningTuningConfig, err error) {
	result = &v1alpha1.NetAppThinProvisioningTuningConfig{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("netappthinprovisioningtuningconfigs").
		Name(netAppThinProvisioningTuningConfig.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppThinProvisioningTuningConfig).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the netAppThinProvisioningTuningConfig and deletes it. Returns an error if one occurs.
func (c *netAppThinProvisioningTuningConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappthinprovisioningtuningconfigs").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *netAppThinProvisioningTuningConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappthinprovisioningtuningconfigs").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched netAppThinProvisioningTuningConfig.
func (c *netAppThinProvisioningTuningConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppThinProvisioningTuningConfig, err error) {
	result = &v1alpha1.NetAppThinProvisioningTuningConfig{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("netappthinprovisioningtuningconfigs").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
