/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppThinProvisioningTuningConfigLister helps list NetAppThinProvisioningTuningConfigs.
// All objects returned here must be treated as read-only.
type NetAppThinProvisioningTuningConfigLister interface {
	// List lists all NetAppThinProvisioningTuningConfigs in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppThinProvisioningTuningConfig, err error)
	// NetAppThinProvisioningTuningConfigs returns an object that can list and get NetAppThinProvisioningTuningConfigs.
	NetAppThinProvisioningTuningConfigs(namespace string) NetAppThinProvisioningTuningConfigNamespaceLister
	NetAppThinProvisioningTuningConfigListerExpansion
}

// netAppThinProvisioningTuningConfigLister implements the NetAppThinProvisioningTuningConfigLister interface.
type netAppThinProvisioningTuningConfigLister struct {
	indexer cache.Indexer
}

// NewNetAppThinProvisioningTuningConfigLister returns a new NetAppThinProvisioningTuningConfigLister.
func NewNetAppThinProvisioningTuningConfigLister(indexer cache.Indexer) NetAppThinProvisioningTuningConfigLister {
	return &netAppThinProvisioningTuningConfigLister{indexer: indexer}
}

// List lists all NetAppThinProvisioningTuningConfigs in the indexer.
func (s *netAppThinProvisioningTuningConfigLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppThinProvisioningTuningConfig, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppThinProvisioningTuningConfig))
	})
	return ret, err
}

// NetAppThinProvisioningTuningConfigs returns an object that can list and get NetAppThinProvisioningTuningConfigs.
func (s *netAppThinProvisioningTuningConfigLister) NetAppThinProvisioningTuningConfigs(namespace string) NetAppThinProvisioningTuningConfigNamespaceLister {
	return netAppThinProvisioningTuningConfigNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppThinProvisioningTuningConfigNamespaceLister helps list and get NetAppThinProvisioningTuningConfigs.
// All objects returned here must be treated as read-only.
type NetAppThinProvisioningTuningConfigNamespaceLister interface {
	// List lists all NetAppThinProvisioningTuningConfigs in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppThinProvisioningTuningConfig, err error)
	// Get retrieves the NetAppThinProvisioningTuningConfig from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppThinProvisioningTuningConfig, error)
	NetAppThinProvisioningTuningConfigNamespaceListerExpansion
}

// netAppThinProvisioningTuningConfigNamespaceLister implements the NetAppThinProvisioningTuningConfigNamespaceLister
// interface.
type netAppThinProvisioningTuningConfigNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppThinProvisioningTuningConfigs in the indexer for a given namespace.
func (s netAppThinProvisioningTuningConfigNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppThinProvisioningTuningConfig, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppThinProvisioningTuningConfig))
	})
	return ret, err
}

// Get retrieves the NetAppThinProvisioningTuningConfig from the indexer for a given namespace and name.
func (s netAppThinProvisioningTuningConfigNamespaceLister) Get(name string) (*v1alpha1.NetAppThinProvisioningTuningConfig, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappthinprovisioningtuningconfig"), name)
	}
	return obj.(*v1alpha1.NetAppThinProvisioningTuningConfig), nil
}
